// srvritem.cpp : implementation of the CGIFServerItem class
//

#include "stdafx.h"
#include "gifserv.h"

#include "srvrdoc.h"
#include "srvritem.h"

#ifdef _DEBUG
#undef THIS_FILE
static char BASED_CODE THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CGIFServerItem implementation

IMPLEMENT_DYNAMIC(CGIFServerItem, COleServerItem)

CGIFServerItem::CGIFServerItem(CGIFServerDoc* pContainerDoc)
	: COleServerItem(pContainerDoc, TRUE)
{
	// TODO: add one-time construction code here
	//  (eg, adding additional clipboard formats to the item's data source)
}

/////////////////////////////////////////////////////////////////////////////
CGIFServerItem::~CGIFServerItem()
{
	// TODO: add cleanup code here
}


/////////////////////////////////////////////////////////////////////////////
void CGIFServerItem::Serialize(CArchive& ar)
{
	// CGIFServerItem::Serialize will be called by the framework if
	//  the item is copied to the clipboard.  This can happen automatically
	//  through the OLE callback OnGetClipboardData.  A good default for
	//  the embedded item is simply to delegate to the document's Serialize
	//  function.  If you support links, then you will want to serialize
	//  just a portion of the document.

	if (!IsLinkedItem())
	{
		CGIFServerDoc* pDoc = GetDocument();
		ASSERT_VALID(pDoc);
		pDoc->Serialize(ar);
	}
}


/////////////////////////////////////////////////////////////////////////////
BOOL CGIFServerItem::OnGetExtent(DVASPECT dwDrawAspect, CSize& rSize)
{
	// Most applications, like this one, only handle drawing the content
	//  aspect of the item.  If you wish to support other aspects, such
	//  as DVASPECT_THUMBNAIL (by overriding OnDrawEx), then this
	//  implementation of OnGetExtent should be modified to handle the
	//  additional aspect(s).

	if (dwDrawAspect != DVASPECT_CONTENT)
		return COleServerItem::OnGetExtent(dwDrawAspect, rSize);

	// CGIFServerItem::OnGetExtent is called to get the extent in
	//  HIMETRIC units of the entire item.  The default implementation
	//  here simply returns a hard-coded number of units.

	CGIFServerDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	// TODO: replace this arbitrary size

	rSize = pDoc->getDocSize();

	return TRUE;
}


/////////////////////////////////////////////////////////////////////////////
BOOL CGIFServerItem::OnDraw(CDC* pDC, CSize& rSize)
{
	TRACE("CGIFServerItem::OnDraw(); size= %d %d", rSize.cx, rSize.cy);

	CGIFServerDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	// TODO: set mapping mode and extent
	//  (The extent is usually the same as the size returned from OnGetExtent)
//	CSize size = pDoc->getDocSize();

//	pDC->SetMapMode(MM_TEXT);
//	pDC->SetWindowOrg(0,0);
//	pDC->SetWindowExt(size);

	// TODO: add drawing code here.  Optionally, fill in the HIMETRIC extent.
	//  All drawing takes place in the metafile device context (pDC).

	CRect clientRect(CPoint(0,0), rSize);
	
	pDoc->draw(*pDC, clientRect);

	return TRUE;
}


/////////////////////////////////////////////////////////////////////////////
// CGIFServerItem diagnostics

#ifdef _DEBUG
void CGIFServerItem::AssertValid() const
{
	COleServerItem::AssertValid();
}

void CGIFServerItem::Dump(CDumpContext& dc) const
{
	COleServerItem::Dump(dc);
}
#endif

/////////////////////////////////////////////////////////////////////////////
